<template>
  <ObModal
    ref="modal"
    title="Добавление корректировки"
    size="md"
  >
    <ob-form
      class="order-additional-service-form"
      data-qa="additionalServiceForm"
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="!isNew"
      ok-text="Добавить"
      :is-loading="isLoading"
      @submit="onSubmitHandler"
    >
      <StatusBlock
        v-if="!isNew"
        :service="dataSource"
        :order="order"
        :is-large="true"
        class="mb30"
      />
      <div class="row">
        <div class="col-xs-6">
          <ObInput
            label="Заказчик"
            :readonly="true"
            :value="order.clientTitle"
            data-qa="clientTitle"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Исполнитель"
            :readonly="true"
            :value="order.contractorTitle"
            data-qa="contractorTitle"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ObSelect
            v-if="isNew"
            :value="correctionInfo && correctionInfo.uuid"
            label="Наименование корректировки"
            placeholder="Выберите из списка"
            :remote-opt="{
              method: api.orderProcess.listOfNonFinancialAdjustments,
              arguments: {
                orderKind: currentOrderKind
              },
              loadEvent: 'open'
            }"
            :is-standart="true"
            data-qa="correctionList"
            @selected="onSelectCorrection"
          />
          <ObInput
            v-else
            :value="dataSource.title"
            :readonly="!isNew"
            label="Наименование корректировки"
            data-qa="correctionTitle"
          />
        </div>
      </div>
      <template v-if="correctionInfo">
        <div class="title">Текущее значение</div>

        <template v-if="currentFieldType === FIELD_TYPES.TEXT">
          <ObInput
            :label="correctionInfo.title"
            :value="currentValueTitle || '-'"
            :readonly="true"
            data-qa="currentValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.NUMERIC">
          <ObInput
            :label="correctionInfo.title"
            :value="currentValueTitle"
            type="money:2"
            :is-convert-money="isConvertMoney"
            :readonly="true"
            data-qa="currentValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.DATETIME">
          <ObDatepicker
            :label="correctionInfo.title"
            :value="currentValueTitle"
            :disabled="true"
            data-qa="currentValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.DROPDOWN_LIST">
          <ObInput
            :label="correctionInfo.title"
            :value="currentValueTitle"
            :readonly="true"
            data-qa="currentValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.MULTIFIELDS">
          <template v-if="currentCorrectionCode === CORRECTION_CODES.ROUTE">
            <OrderCorrectionRoute
              :route="currentRoute"
              :is-readonly="true"
            />
          </template>
          <template v-if="currentCorrectionCode === CORRECTION_CODES.RESOURCES">
            <OrderCorrectionResources
              :order="order"
              :resources="currentResources"
              :is-readonly="true"
            />
          </template>
        </template>

        <div class="title">Новое значение</div>

        <template v-if="currentFieldType === FIELD_TYPES.TEXT">
          <ObInput
            :label="correctionInfo.title"
            :value="newValueTitle"
            placeholder="Введите значение"
            data-qa="newValue"
            @input="onChangeNewValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.NUMERIC">
          <ObInput
            :label="correctionInfo.title"
            :value="newValueTitle"
            placeholder="Введите значение"
            type="money:2"
            :is-convert-money="isConvertMoney"
            data-qa="newValue"
            @input="onChangeNewValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.DATETIME">
          <ObDatePicker
            :label="correctionInfo.title"
            :value="newValueTitle"
            data-qa="newValue"
            @input="onChangeNewValue"
          />
        </template>
        <template v-if="[FIELD_TYPES.DROPDOWN_LIST, FIELD_TYPES.RESOURCE_TYPE].includes(currentFieldType)">
          <ObSelect
            :value="newValueId"
            :label="correctionInfo.title"
            placeholder="Выберите из списка"
            :remote-opt="getNewValuesByType"
            :remote-trigger="correctionInfo.uuid"
            :is-standart="true"
            :display-exp="keysByCorrectionCode.displayExp"
            :value-exp="keysByCorrectionCode.valueExp"
            data-qa="newValue"
            @selected="onChangeNewValue"
          />
        </template>
        <template v-if="currentFieldType === FIELD_TYPES.MULTIFIELDS">
          <template v-if="currentCorrectionCode === CORRECTION_CODES.ROUTE">
            <OrderCorrectionRoute
              :route="newRoute"
              @change="onChangeRoute"
            />
          </template>
          <template v-if="currentCorrectionCode === CORRECTION_CODES.RESOURCES">
            <OrderCorrectionResources
              :order="order"
              :resources="newResources"
              @change="onChangeResource"
            />
          </template>
        </template>
        <ObTextarea
          v-model="formData.comments"
          label="Комментарий"
          placeholder="Введите комментарий"
          class="mb30 mt30"
          :readonly="!isNew"
        />
        <template v-if="formData.fileUuids && formData.fileUuids.length || isNew">
          <div class="title">Прикрепленные файлы</div>
          <ObUploader
            ref="uploader"
            multiple
            :value="currentFiles"
            data-qa="uploader"
            :is-read-only="!isNew"
            :upload-method="uploadMethod"
            @process-start="startUploadFiles"
            @change="onUploadHandler"
          />
        </template>
      </template>
    </ob-form>
  </ObModal>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import ObDatepicker from 'common-components/src/obComponents/obDatePickerConstructor'
  import StatusBlock from '@/components/Order/orderItem/services/additionalServices/slots/status'
  import OrderCorrectionRoute from '@/components/Order/orderItem/services/nonFinancialAdjustment/route'
  import OrderCorrectionResources from '@/components/Order/orderItem/services/nonFinancialAdjustment/resources'
  import { required, minLength } from 'vuelidate/lib/validators'

  const setToValue = (obj, value, path) => {
    let i
    path = path.split('.')
    for (i = 0; i < path.length - 1; i++) {
      obj = obj[path[i]]
      if (!obj) break
    }

    if (obj) {
      obj[path[i]] = value
    }
  }

  const FIELD_TYPES = {
    DROPDOWN_LIST: 'DROPDOWN_LIST',
    TEXT: 'TEXT',
    NUMERIC: 'NUMERIC',
    DATETIME: 'DATETIME',
    MULTIFIELDS: 'MULTIFIELDS'
  }

  const CORRECTION_CODES = {
    CONTRACT: 'CONTRACT',
    COMPANY: 'COMPANY',
    DRIVER: 'DRIVER',
    TRACTOR: 'TRACTOR',
    SEMITRAILER: 'SEMITRAILER',
    CLICAR_LOGIST: 'CLICAR_LOGIST',
    RESOURCE_TYPE: 'RESOURCE_TYPE',
    ROUTE: 'ROUTE',
    RESOURCES: 'RESOURCES'
  }

  export default {
    name: 'OrderAdditionalServiceForm',
    components: {
      ObSelect,
      ObInput,
      ObForm,
			ObModal,
      ObUploader,
      StatusBlock,
      ObTextarea,
      ObDatepicker,
      OrderCorrectionRoute,
      OrderCorrectionResources
    },
    props: {
      order: {
        type: Object,
        default: () => {}
      },
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        isLoading: false,
        correctionInfo: null
      }
    },
    watch: {
      'formData.fileUuids': {
        handler (value) {
          if (!value) {
            this.$refs.uploader && this.$refs.uploader.clearFiles()
          }
        },
        deep: true
      }
    },
    computed: {
      ...mapGetters({
        participantUuid: 'user/participantUuid',
        isClicar: 'user/isClicar',
        firstOrder: 'order/order'
      }),
      FIELD_TYPES () {
        return FIELD_TYPES
      },
      CORRECTION_CODES () {
        return CORRECTION_CODES
      },
      keysByCorrectionCode () {
        const keysMap = {
          [CORRECTION_CODES.CONTRACT]: {
            displayExp: 'number',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.COMPANY]: {
            displayExp: 'title',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.DRIVER]: {
            displayExp: 'fio',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.TRACTOR]: {
            displayExp: 'number',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.SEMITRAILER]: {
            displayExp: 'number',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.CLICAR_LOGIST]: {
            displayExp: 'title',
            valueExp: 'uuid'
          },
          [CORRECTION_CODES.RESOURCE_TYPE]: {
            displayExp: 'value',
            valueExp: 'uuid'
          }
        }

        return keysMap[this.currentCorrectionCode] || {}
      },
      isNew () {
        return !this.dataSource.uuid
      },
      isSuborder () {
        return this.order.isSuborder
      },
      currentOrderKind () {
        return this.isSuborder ? 'SUBORDER' : 'ORDER'
      },
      currentFieldType () {
        return this.correctionInfo?.fieldType
      },
      currentCorrectionCode () {
        return this.correctionInfo?.code
      },
      isDropdownList () {
        return this.currentFieldType === FIELD_TYPES.DROPDOWN_LIST
      },
      isConvertMoney () {
        return ['CARGO_INSURANCE_COST'].includes(this.currentCorrectionCode)
      },
      formModel () {
        const _self = this

        let newValueValidator

        if (this.currentCorrectionCode === CORRECTION_CODES.ROUTE) {
          newValueValidator = {
            nested_fields: {
              route: {
                value: () => _self.currentRoute,
                validator: {
                  minLength: minLength(2),
                  $each: {
                    ordinal: {
                      value: '',
                      validator: {
                        required
                      }
                    },
                    title: {
                      value: ''
                    },
                    addressTitle: {
                      value: '',
                      validator: {
                        required
                      }
                    },
                    direction: {
                      value: '',
                      validator: {
                        required
                      }
                    },
                    slotStartAt: {
                      value: '',
                      validator: {
                        required
                      }
                    },
                    slotEndAt: {
                      value: '',
                      validator: {
                        required
                      }
                    }
                  }
                }
              }
            }
          }
        } else if (this.currentCorrectionCode === CORRECTION_CODES.RESOURCES) {
          newValueValidator = {
            nested_fields: {
              assignedResources: {
                value: () => _self.currentResources
              }
            }
          }
        } else {
          newValueValidator = {
            nested_fields: {
              value: {
                value: null,
                validator: {
                  required
                }
              },
              uuid: {
                value: '',
              }
            }
          }
        }

        return {
          orderUuid: {
            value: () => _self.order.uuid
          },
          orderKind: {
            value: () => _self.currentOrderKind
          },
          currentValue: {
            value: () => _self.dataSource?.currentValue || _self.correctionInfo?.currentValue
          },
          newValue: {
            value: () => _self.dataSource?.currentValue || _self.correctionInfo?.currentValue,
            ...newValueValidator
          },
          comments: {
            value: ''
          },
					fileUuids: {
						value: null
					}
        }
      },
      isCreator () {
        return this.dataSource.creatorUuid === this.participantUuid
      },
      currentValueTitle () {
        return this.formData?.currentValue?.value || null
      },
      currentRoute () {
        return this.formData?.currentValue?.route || []
      },
      currentResources () {
        return this.formData?.currentValue?.assignedResources || []
      },
      newRoute () {
        return this.formData?.newValue?.route || []
      },
      newResources () {
        return this.formData?.newValue?.assignedResources || []
      },
      newValueTitle () {
        return this.formData?.newValue?.value || null
      },
      newValueId () {
        return this.formData?.newValue?.uuid || null
      },
			uploadMethod () {
				return api.files.postFile
			},
			currentFiles () {
				return this.dataSource.filesData
			}
    },
    methods: {
      open () {
        this.correctionInfo = null
        this.$refs.modal.open()
      },
      close () {
        this.$refs.modal.close()
      },
      onChangeField ({ path, value }) {
        setToValue(this.formData, value, path)
      },
      onChangeRoute ({ path, value }) {
        if (!path) {
          value = value.map((item, index) => {
            return {
              ...item,
              ordinal: index + 1
            }
          })
        }
        this.onChangeField({ path: `newValue.route${path ? '.' + path : ''}`, value })
      },
      onChangeResource ({ path, value }) {
        if (!path) {
          value = value.map((item) => {
            return {
              ...item
            }
          })
        }
        this.onChangeField({ path: `newValue.assignedResources${path ? '.' + path : ''}`, value })
      },
      async onSelectCorrection (data) {
        try {
          const correctionInfo = await api.orderProcess.getDataOfNonFinancialAdjustments({
            typeUuid: data.uuid,
            orderUuid: this.order.uuid,
            orderKind: this.currentOrderKind
          })

          this.correctionInfo = {
            ...data,
            ...correctionInfo
          }

          this.formData.currentValue = correctionInfo.currentValue
          this.formData.newValue = {
            value: null,
            uuid: null
          }
        } catch (e) {
          console.log(e)
        }
      },
      async getNewValuesByType ({ page, size, query }) {
        const paginateParams = {
          page, size, query
        }
        const { clientUuid, contractorUuid } = this.order

        if (this.currentCorrectionCode === CORRECTION_CODES.CONTRACT) {
          return await api.orderProcess.getExternalNumberList({ ...paginateParams, clientUuid, doerUuid: contractorUuid })
        }

        if (this.currentCorrectionCode === CORRECTION_CODES.CLICAR_LOGIST) {
          return this.isSuborder
            ? await api.orderProcess.getSuborderLogisticians({ uuid: this.order.uuid })
            : await api.orderProcess.responsibleWorkers(  { ...paginateParams, clientUuid, contractorUuid })
        }

        if (this.currentCorrectionCode === CORRECTION_CODES.COMPANY) {
          return await api.orderProcess.participantsByRoles({
            ...paginateParams,
            code: this.order.isSuborder ? 'carrier' : 'client'
          })
        }

        if ([CORRECTION_CODES.DRIVER, CORRECTION_CODES.TRACTOR, CORRECTION_CODES.SEMITRAILER].includes(this.currentCorrectionCode)) {
          return await api.orderProcess.resourcesByParticipant({
            ...paginateParams,
            carrierUuid: contractorUuid,
            code: this.currentCorrectionCode
          })
        }

        if (this.currentCorrectionCode === CORRECTION_CODES.RESOURCE_TYPE) {
          return await api.orderProcess.nonFinancialAdjustmentsDropdown({
            ...paginateParams,
            orderUuid: this.order.uuid,
            orderKind: this.currentOrderKind,
            typeUuid: this.correctionInfo.uuid
          })
        }
      },
      async onChangeNewValue (data) {
        let newValue

        if (this.isDropdownList) {
          newValue = {
            uuid: data[this.keysByCorrectionCode.valueExp],
            value: data[this.keysByCorrectionCode.displayExp]
          }
        } else {
          newValue = {
            uuid: null,
            value: data
          }
        }

        this.formData.newValue = { ...newValue }
      },
      async onSubmitHandler () {
        await this.addService()
      },
			startUploadFiles () {
				this.formData.fileUuids = 'loading'
			},
			async onUploadHandler (data) {
				data = data.map(file => file.uuid)

				this.formData.fileUuids = data
			},
      async addService () {
        let data = cloneDeep(this.formData)

        data.typeUuid = this.correctionInfo.uuid
        data.code = this.correctionInfo.code
        data.oldValue = data.currentValue

        if (this.currentCorrectionCode === CORRECTION_CODES.ROUTE) {
          data.newValue.route = data.newValue.route.map((item, index) => {
            return {
              ...item,
              ordinal: index + 1,
              title: item.addressTitle
            }
          })
        }

        try {
          this.isLoading = true
          await api.orderProcess.addNonFinancialAdjustment({ data })
          this.$notification({
            type: 'system_notification_success',
            message: 'Корректировка успешно добавлена'
          })

          this.close()
          this.correctionInfo = null

          this.$emit('submitted')
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: e?.error
          })
        } finally {
          this.isLoading = false
        }
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-link {
    height: 100%;
    display: flex;
    align-items: center;
    a {
      margin-left: 5px;
    }
  }

  .contract-service-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .tariff-input {
      width: 193px;
    }
  }

	.confirm-modal__info {
		p {
			margin-bottom: 25px;
			font-size: 16px!important;
		}
		.info-row {
			display: flex;
			margin-bottom: 2px;
			@include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
			.title {
				width: 140px;
				color: $color-grey-label;
			}
			.description {

			}
		}
	}
</style>

<style lang="scss" scoped>
  @import '../../../../../../node_modules/common-components/src/static/css/mixins';
  .order-additional-service-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb15 {
      margin-bottom: 15px!important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .mt30 {
      margin-top: 30px!important;
    }

    .mb40 {
      margin-bottom: 30px!important;
    }

    .mt40 {
      margin-top: 40px !important;
    }

    .ml25 {
      margin-left: 25px;
    }

    &::v-deep {
      .ob-checkbox-container {
        margin-bottom: 8px;
      }
      .service-title__status {
        color: $color-text-base!important;
      }
      .service-status__row {
        margin-bottom: 10px;
      }
    }

    .title {
      margin-top: 30px;
      margin-bottom: 5px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }

    .nds-block {
      margin-left: 20px;
      .title {
        margin-top: 0!important;
      }
    }

    .international-block {
      height: 64px;
      margin-top: 30px;
      margin-bottom: 30px;
      display: flex;
      align-items: center;
      padding: 0 20px;
      border-left: 6px solid $diamond-orange-yellow;
      box-shadow: 0px 4px 20px rgba(25, 30, 50, 0.2);
      svg {
        margin-right: 20px;
      }
      span {
        @include font-mixin(14px, 18px, 400);
      }
    }

    .color-error {
      button {
        color: $color-error;
      }
    }

    .fadeIn-enter,
    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active,
    .fadeIn-leave-active {
      transition: opacity .3s ease-in-out;
    }
  }
</style>
